unit Ole_1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExcelXP, OleServer, Grids, Wwdbigrd, Wwdbgrid, DB,
  Wwdatsrc, ADODB, ComCtrls, OleCtnrs;

type
  TForm1 = class(TForm)
    XLApp: TExcelApplication;
    ADOConnection1: TADOConnection;
    CarsTB: TADOTable;
    CarsDS: TwwDataSource;
    CarsTBCarName: TStringField;
    CarsTBCost: TBCDField;
    CarsTBSalvage: TBCDField;
    CarsTBLife: TIntegerField;
    CarsTBMonth_ID: TIntegerField;
    CarsTBDepreciation: TCurrencyField;
    pg1: TPageControl;
    tsBasic: TTabSheet;
    tsDataPush: TTabSheet;
    btnConnect: TButton;
    Button1: TButton;
    Button4: TButton;
    edtAddToA1: TEdit;
    Button6: TButton;
    tsCalc: TTabSheet;
    edtNum1: TEdit;
    Label2: TLabel;
    edtNum2: TEdit;
    btnSums: TButton;
    tsFormula: TTabSheet;
    btnDDB: TButton;
    Button8: TButton;
    Label1: TLabel;
    edtCarPrice: TEdit;
    Label8: TLabel;
    edtSalvagePrice: TEdit;
    Label9: TLabel;
    edtLife: TEdit;
    Label10: TLabel;
    edtMonthNumber: TEdit;
    lblCarDep: TLabel;
    TabSheet1: TTabSheet;
    Button7: TButton;
    btnShowCars: TButton;
    grdCars: TwwDBGrid;
    lblSum: TLabel;
    Button3: TButton;
    btnFormatting: TButton;
    Button2: TButton;
    cbDelphiFormat: TCheckBox;
    tsSaveWorkbook: TTabSheet;
    wwDBGrid1: TwwDBGrid;
    Cars2TB: TADOTable;
    Car2DS: TwwDataSource;
    btnOpenCars2: TButton;
    btnPushDataToExcel: TButton;
    btnSaveWorkbook: TButton;
    Cars2TBCarName: TStringField;
    Cars2TBCost: TBCDField;
    Cars2TBSalvage: TBCDField;
    Cars2TBLife: TIntegerField;
    Cars2TBMonth_ID: TIntegerField;
    btnApplyFormatting: TButton;
    btnDiscandQuit: TButton;
    tsContainer: TTabSheet;
    OleContainer1: TOleContainer;
    procedure Button1Click(Sender: TObject);
    function LoadExcel : boolean;
    procedure CreateSheet(SheetPosition : Integer;aName : string);
    procedure Button2Click(Sender: TObject);
    procedure UnLoadExcel;
    procedure btnSumsClick(Sender: TObject);
    procedure btnUnloadExcelClick(Sender: TObject);
    procedure btnDDBClick(Sender: TObject);
    procedure edtCarPriceChange(Sender: TObject);
    procedure CarsTBCalcFields(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure btnShowCarsClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnOpenCars2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DoSimpleSum(sender: Tobject);
    procedure Button8Click(Sender: TObject);
    procedure SetExcelCell(row, col : integer; somevalue : string);
    function ReadExcelCell(row, col : integer) : string;
    procedure btnFormattingClick(Sender: TObject);
    procedure cbDelphiFormatClick(Sender: TObject);
    procedure btnPushDataToExcelClick(Sender: TObject);
    procedure btnApplyFormattingClick(Sender: TObject);
    procedure btnSaveWorkbookClick(Sender: TObject);
    procedure btnDiscandQuitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IIndex : OleVariant;
  WorkBk : _Workbook;
  WorkSheet : _Worksheet;
  ExcelVersion : double;
  row, col : integer;
  OKToCalcDepr : boolean;
  XLConnected  : boolean;
  lcid : integer;

implementation

{$R *.dfm}
//..............................................................................
procedure TForm1.Button1Click(Sender: TObject);
begin
  try
    XLApp.Connect;
    showmessage('Excel installed and working');
  except
    raise;
  end;
end;
//..............................................................................

function Tform1.LoadExcel(): boolean;
//gets Excel going if possible - returns true or false
var
  XLVerAsStr : string;
begin
  try
    IIndex := 1;
    XLApp.Connect;
    lcid := LOCALE_USER_DEFAULT;
    XLVerAsStr := XLApp.Version[lcid];
    ExcelVersion := StrToFloat(XLVerAsStr);
    XLApp.Workbooks.Add(xlWBatWorksheet,0);
    WorkBk := XLApp.Workbooks.Item[IIndex];
    XLConnected := True;
    result := True;
  except
    begin
        XLConnected := False;
        showmessage('Cannot load Excel, please contact your IT department for assisstance.');
        result := False;
    end;
  end;
end;
//..............................................................................
procedure Tform1.CreateSheet(SheetPosition : Integer;aName : string);
begin
//create a worksheet
  Worksheet := WorkBk.Worksheets.get_item(SheetPosition) as _Worksheet;
  Worksheet.Name := aName;
end;
//..............................................................................
procedure TForm1.Button2Click(Sender: TObject);
begin
//here we are going to connect to Excel, load up a blank workbook, and a worksheet
//then push into cell A1 the value held in edit1 and then make the Excel workbook visible

  if Not LoadExcel then exit;
  CreateSheet(1,'Test Sheet');
  Worksheet.Cells.Item[1,1].value2 := edtAddToA1.Text;
  UnloadExcel;
end;
//..............................................................................
function TForm1.ReadExcelCell(row, col : integer) : string;
begin
//this functions just checks what version of Excel we are connected to
//before reading data

if ExcelVersion > 10 then
  result := Worksheet.Cells.Item[row,col].value2
  //2
else
  result := Worksheet.Cells.Item[row,col].value;
end;
//..............................................................................

procedure TForm1.SetExcelCell(row, col : integer; somevalue : string);
begin
//this functions just checks what version of Excel we are connected to
//before reading data
if ExcelVersion > 10 then
  Worksheet.Cells.Item[row,col].value2 := somevalue
else
  Worksheet.Cells.Item[row,col].value  := somevalue;
end;
//..............................................................................
procedure Tform1.UnLoadExcel;
begin
  try
    if XLConnected then
      begin
        XLApp.Disconnect;
        XLConnected := False;
      end;
    showmessage('Excel disconnected and no longer running');
  except
    //do nothing particular
    raise;
  end;
end;
//..............................................................................
procedure TForm1.btnSumsClick(Sender: TObject);
begin
  if Not XLConnected then
    begin
      if Not LoadExcel then exit;
    end;
  CreateSheet(1,'Test Sheet');
  SetExcelCell(1,1,edtNum1.Text);
  SetExcelCell(1,2,edtNum2.Text);
  SetExcelCell(1,3,'=SUM(A1:B1)');

  lblsum.Caption   := ReadExcelCell(1,3);
  edtNum1.OnChange := DoSimpleSum;
  edtNum2.OnChange := DoSimpleSum;
end;
//..............................................................................
procedure TForm1.DoSimpleSum(sender: Tobject);
begin
  //this just assumes that Excel is connected and we can push data into a
  //couple of cells and get the 'answer' back
  SetExcelCell(1,1,edtNum1.Text);
  SetExcelCell(1,2,edtNum2.Text);
  lblsum.Caption := ReadExcelCell(1,3);
end;
//..............................................................................
procedure TForm1.btnUnloadExcelClick(Sender: TObject);
begin
  UnloadExcel;
end;
//..............................................................................

procedure TForm1.btnDDBClick(Sender: TObject);
begin
  //set up Excel and set event handler on change to edit boxes
  if Not XLConnected then
    begin
      if Not LoadExcel then exit;
    end;

  CreateSheet(1,'Car Depreciation');
  SetExcelCell(1,1,edtCarPrice.Text);
  SetExcelCell(1,2,edtSalvagePrice.Text);
  SetExcelCell(1,3,edtLife.Text);
  SetExcelCell(1,4,edtMonthNumber.Text);
  SetExcelCell(1,5,'=IF(IsError(DB(A1,B1,C1,D1)),-1,DB(A1,B1,C1,D1))');
  if cbDelphiFormat.Checked then
    lblCarDep.Caption := 'Car Depreciation = ' + FloatToStrf(strToFloat(ReadExcelCell(1,5)),fffixed,8,2)
  else
    lblCarDep.Caption := 'Car Depreciation = ' + ReadExcelCell(1,5);

  //setup flag to indicate workbook open and ready
  OKToCalcDepr := True;
  btnShowCars.enabled := True;
end;
//..............................................................................

procedure TForm1.edtCarPriceChange(Sender: TObject);
begin
  //recalc from the Excel sheet
  SetExcelCell(1,1,edtCarPrice.Text);
  SetExcelCell(1,2,edtSalvagePrice.Text);
  SetExcelCell(1,3,edtLife.Text);
  SetExcelCell(1,4,edtMonthNumber.Text);
  if cbDelphiFormat.Checked then
    lblCarDep.Caption := 'Car Depreciation = ' + FloatToStrf(strToFloat(ReadExcelCell(1,5)),fffixed,8,2)
  else
    lblCarDep.Caption := 'Car Depreciation = ' + ReadExcelCell(1,5);
end;
//..............................................................................

procedure TForm1.CarsTBCalcFields(DataSet: TDataSet);
begin
 if OKToCalcDepr then
  begin
    with CarsTB do
      begin
        if FieldByName('Cost').asFloat <> 0.00 then SetExcelCell(1,1,FieldByName('Cost').asstring);
        if FieldByName('Salvage').asFloat <> 0.00 then SetExcelCell(1,2,FieldByName('Salvage').asstring);
        if FieldByName('Life').asInteger <> 0 then SetExcelCell(1,3,FieldByName('Life').asstring);
        if FieldByName('Month_ID').asInteger <> 0 then SetExcelCell(1,4,FieldByName('Month_ID').asstring);
        FieldByName('Depreciation').asFloat := StrToFloat(ReadExcelCell(1,5));
      end;

  end;
end;
//..............................................................................

procedure TForm1.FormCreate(Sender: TObject);
begin
OKToCalcDepr := False;
pg1.ActivePageIndex := 0;
end;
//..............................................................................

procedure TForm1.btnShowCarsClick(Sender: TObject);
begin
  if XLConnected then CarsTB.Open;
end;
//..............................................................................

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  try
    XLApp.Connect;
    XLConnected := True;
    showmessage('Excel up and running');
  except
    on Exception do
    begin
      XLConnected := False;
      showmessage('Trying to connect to Excel raised the following error : ');
    end;
  end;
end;
//..............................................................................
procedure TForm1.Button4Click(Sender: TObject);
begin
  if Not LoadExcel then exit;
  CreateSheet(1,'Test Sheet');
  SetExcelCell(1,1,edtAddToA1.Text);
end;
//..............................................................................
procedure TForm1.Button3Click(Sender: TObject);
begin
  if XLConnected then
    begin
      XLApp.Visible[lcid] := True;
    end;
end;
//..............................................................................
procedure TForm1.Button8Click(Sender: TObject);
begin
  edtNum1.OnChange := nil;
  edtNum2.OnChange := nil;
  UnLoadExcel;
end;
//..............................................................................

procedure TForm1.btnFormattingClick(Sender: TObject);
begin
  //apply the formatting
  Worksheet.range['E1','E1'].NumberFormat := '0.00';
end;
//..............................................................................
//..............................................................................

procedure TForm1.cbDelphiFormatClick(Sender: TObject);
begin
if XLConnected then edtCarPriceChange(sender);
end;
//..............................................................................

procedure TForm1.btnOpenCars2Click(Sender: TObject);
begin
  if NOT LoadExcel then exit;
  CreateSheet(1,'We Sell Cars We Do');
  Cars2TB.Open;
end;
//..............................................................................

procedure TForm1.btnPushDataToExcelClick(Sender: TObject);
var
  FormulaStr : string;
begin
//we want to push this data and the odd formula to Excel
CreateSheet(1,'We Sell Cars We Do');
with Cars2TB do
  begin
    if not active then open;
    row := 1;
    col := 1;
    //ok, push in some headings for the user

    SetExcelCell(row,col,'We Sell Cars We Do');
    row := row + 2;
    SetExcelCell(row, col, 'Car Name');
    SetExcelCell(row, col + 1, 'Original Cost');
    SetExcelCell(row, col + 2, 'Salvage Cost');
    SetExcelCell(row, col + 3, 'Car Life In Months');
    SetExcelCell(row, col + 4, 'Month Number');
    SetExcelCell(row, col + 5, 'Depreciation In This Month');
    row := row + 2;

    while not eof do
      begin
        //take each record and push it into Excel
        SetExcelCell(row, col, FieldByName('CarName').asstring);
        SetExcelCell(row, col + 1, FieldByName('Cost').asstring);
        SetExcelCell(row, col + 2, FieldByName('Salvage').asstring);
        SetExcelCell(row, col + 3, FieldByName('Life').asstring);
        SetExcelCell(row, col + 4, FieldByName('Month_ID').asstring);

        FormulaStr := '=IF(IsError(DB(RC[-4],RC[-3],RC[-2],RC[-1])),-1,DB(RC[-4],RC[-3],RC[-2],RC[-1]))';
        SetExcelCell(row, col + 5,FormulaStr);
        inc(row);
        next;
      end;
    Worksheet.Range['F1','F' + IntToStr(row)].NumberFormat := '0.00';
    close; //database

   //XLApp.Visible[lcid] := True;
  end;
end;
//..............................................................................

procedure TForm1.btnApplyFormattingClick(Sender: TObject);
begin
  //apply the formatting to the car worksheet

  //let's make column A pretty wide
  Worksheet.Range['A1','A1'].ColumnWidth := 20;
  Worksheet.Range['B1','E1'].ColumnWidth := 12;
  Worksheet.Range['F1','F1'].ColumnWidth := 24;

  //make the headings bold
  Worksheet.Range['A3','F3'].Font.Bold := True;

  //amend the depreciation column formatting
  Worksheet.Range['F1','F' + IntToStr(row)].NumberFormat := '0.00';

end;
//..............................................................................

procedure TForm1.btnSaveWorkbookClick(Sender: TObject);
begin
  //save the workbook, overwriting any existing workbook
  Worksheet.SaveAs('C:\Cars.xls',EmptyParam,EmptyParam,EmptyParam,
              EmptyParam,False,EmptyParam,
              EmptyParam,EmptyParam,lcid);
end;
//..............................................................................

procedure TForm1.btnDiscandQuitClick(Sender: TObject);
begin

  //this is where we disconnect from Excel and quit excel
  if XLConnected then
    begin
      XLApp.Disconnect;
      XLApp.Quit;
    end;
end;
//..............................................................................

end.
